def compose(*objects)

  threads = []
  for obj in objects do 
    threads << Thread.new(obj) do |myobj|
      me = Thread.current
      me[:queue] = []
      myobj.each do |element|
        me[:queue].push element
      end
    end
  end

  list = [0]                       # Dummy non-nil value
  while list.nitems > 0 do         # Still some non-nils
    list = []
    for thr in threads
      list << thr[:queue].shift    # Remove one from each
    end
    yield list if list.nitems > 0  # Don't yield all nils
  end

end

x = [1, 2, 3, 4, 5, 6, 7, 8]
y = "  first\n second\n  third\n fourth\n  fifth\n"
z = %w[a b c d e f]


compose(x, y, z) do |a,b,c|
  p [a, b, c]
end

# Output:
#
# [1, "  first\n", "a"]
# [2, " second\n", "b"]
# [3, "  third\n", "c"]
# [4, " fourth\n", "d"]
# [5, "  fifth\n", "e"]
# [6, nil, "f"]
# [7, nil, nil]
# [8, nil, nil]
