require 'nqxml/treeparser'
xml = $<.read

begin
  doc = NQXML::TreeParser.new(xml).document

  root = doc.rootNode
  root.children.each do |node|
    if node.entity.class == NQXML::Tag 
      if node.entity.name == "person" 
        rel = node.entity.attrs['relationship']
        puts "Found a person of type #{rel}."
      end
      node.children.each do |subnode|
        if subnode.entity.class == NQXML::Tag && 
             subnode.entity.name == "name"
          puts "\tName is: #{subnode.children[0].entity}"
        end
      end
    else
      puts node.entity.class
    end
  end

rescue NQXML::ParserError
  # Do something meaningful
end
